const int MAX = 64;
const double radius = 0.05;
const double SPEED = 0.02;

inline int two_to_the(int i) {
    int ret=2,j;
    if (i==0) return(1);
    for (j=1; j<i; j++)
        ret = 2 * ret;
    return(ret);
}

class SortView : public View {
  public:
     int Init(int);
     int AddNode(int, int);
     int Elevate(int);
     int BuildPtr(int);
     int BHToggle();
     int HeapPtr(int);
     int HeapifyDone();
     int CompareLeft(int);
     int CompareBoth(int);
     int Exchange(int, int);
     int Sift(int, int);
     int Done(int);
     int Message(char *);
     int Code(int);
     void AnimateAFrame();
  private:
     Circle *node[MAX];
     Text *label[MAX];
     Line *edge[MAX];
     Loc *tree[MAX];
     Loc *spots[MAX];
     Set *heaproot;
     Circle *heapifier;
     Rectangle *highlight;
};




class Names : public View {
  public:
   int Init(int);
   int Input(int,int);
   int Highlight(int);
   int Exchange(int,int,int);
   int Message(char *);
   int Done(int);
   void AnimateAFrame();

  private:
   Rectangle *barrier;
   int numvals;
   int values[250];
   Text *labels[250];
};





class MyAnimator : public Animator {
  public:
   int Controller();
  private:
   SortView sv;
   Names nv;
};


