

class ArrayView : public View {
  public:
   ArrayView() { max=min=0;};

   int Init();
   int Input(int,int);
   int Ready(int);
   int Exchange(int,int);
   int ExchangePartition(int,int);
   int ShowPartition(int,int);
   int PartitionDone(int);
   int LoPtrChange(int);
   int LoPtrDone(int);
   int HiPtrChange(int);
   int HiPtrDone(int);
   int Range(int,int);
   int Message(char *);
   int Comment(char *);
   void DoAnimationFrame();

  private:
   int values[250];
   int max,min;
   Rectangle *blocks[250];
   Text *labels[250];
   Text *hiPtr,*loPtr;
   Line *loArrow,*hiArrow;
   Rectangle *loBack,*hiBack;
   Rectangle *boundary;
};





class DotsView : public View {
  public:
    DotsView() { partition = NULL; };
    int Init();
    int Input(int,int);
    int Draw(int);
    int Partition(int,int);
    int PartitionDone(int);
    int Range(int,int);
    int Exchange(int,int);
    void DoAnimationFrame();

  private:
    int values[250];
    double spacing;
    Rectangle *elts[250];
    Line *partition;
};





class ValueView : public View {
  public:
   int Init(int);
   int Input(int,int);
   int Exchange(int,int);
   int Message(char *);
   void AnimateAFrame();

  private:
   int numvals;
   int values[250];
   Text *labels[250];
};





class MyAnimator : public Animator {
  public:
    int Controller();
  private:
    ArrayView arrayview;
    DotsView dotsview;
    ValueView valueview;
};









