/***************************************************************/
/*							                                   */
/*	       		PieImpl.h			                           */
/*							                                   */
/***************************************************************/
/*       Copyright 1993, 1997 Georgia Institute of Technology 
                     -- John T. Stasko, Roman S. Khramets      */

#ifndef __PIE_IMPL_H
#define __PIE_IMPL_H

#include "AnimObjectImpl.h"

class PieImpl: public AnimObjectImpl {
  private:
    double radius;
    double begangle;
    double delta;
    char colorname[32];
    COLORINDEX color;
    double fill;
    void drawer(COLORINDEX, FILL_STYLE);
    void transSpecial(char*, double, double);
  public:
    PieImpl(View *view, int v, double lx, double ly, double r, 
             double ba=0.0, double del=1.0, COLOR c="black", double f=0.0);
    PieImpl(const PieImpl&);
    AnimObjectImpl *clone() const     // redef of virtual constructor
       { return new PieImpl(*this); };
    ~PieImpl();
    LocPtr Where(PART);
    void BoundBox(double*, double*, double*, double*);
    void Draw();
    void Erase();
    void GetValues(View**, int *, double *, double *, 
                double *, double *, double *, 
                COLOR, double *);
  };

#endif
