/***************************************************************/
/*							                                   */
/*	       		PolylineImpl.h			                       */
/*							                                   */
/***************************************************************/
/*       Copyright 1993, 1997 Georgia Institute of Technology 
                     -- John T. Stasko, Roman S. Khramets      */

#ifndef __POLYLINE_IMPL_H
#define __POLYLINE_IMPL_H

#include "AnimObjectImpl.h"

class PolylineImpl: public AnimObjectImpl {
  private:
    int vertices;
    double vx[32];
    double vy[32];
    char colorname[32];
    COLORINDEX color;
    double width;
    double style;
    int arrow;
    double arrowf1x,arrowf1y;
    double arrowf2x,arrowf2y;
    double arrowf3x,arrowf3y;
    double arrowf4x,arrowf4y;
    void drawer(COLORINDEX);
    void transSpecial(char *, double, double);
  public:
    PolylineImpl(View *view, int v, double lx, double ly, int ve, 
                double vtx[], double vty[], COLOR c="black", 
                double w=0.0, double s=1.0, int a=0);
    PolylineImpl(const PolylineImpl&);
    AnimObjectImpl *clone() const     // redef of virtual constructor
       { return new PolylineImpl(*this); };
    ~PolylineImpl();
    LocPtr Where(PART);
    void BoundBox(double*, double*, double*, double*);
    void Draw();
    void Erase();
    void GetValues(View**, int *, double *, double *, int *, 
                double[], double[], COLOR, 
                double *, double *, int *);
  };

#endif
